Attribute VB_Name = "mdlAPIGraphics"
'///////////////////////////////////////////
'//
'// mdlAPIGRaphics - a collection of API graphics routines
'//
'// Coded in December 2000 by Fred Garber
'//
'// Also includes BltZoom, written by me
'// Also includes timeGetTime for speed checking
'// Also includes sndPlaySound, for playing sounds
'//
'///////////////////////////////////////////
Option Explicit

Public Declare Function OSWinHelp% Lib "user32" Alias "WinHelpA" (ByVal hwnd&, ByVal HelpFile$, ByVal wCommand%, dwData As Any)
Public Declare Function timeGetTime Lib "winmm.dll" () As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal HDC As Long, ByVal hObject As Long) As Long
Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal HDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal HDC As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal HDC As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long

Public Const PI = 3.14159       'It's always useful to know Pi

Public Const SND_ASYNC = &H1        'Play the sound and keep running
Public Const SND_SYNC = &H0         'Play the sound, and pause while you do so
Public Const SND_NOWAIT = &H2000    'Play the sound immediately ???
Public Const SND_LOOP = &H8         'Play the sound and loop until the next sound ???

Public Function BltZoom(ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long, ByVal nXZoom As Single, ByVal nYZoom As Single) As Long
Dim ii As Integer, jj As Integer, XD As Integer, YD As Integer
    
XD = nWidth * nXZoom
YD = nHeight * nYZoom
    
    For jj = 0 To YD - 1
        For ii = 0 To XD - 1
            BitBlt hDestDC, X + ii, Y + jj, 1, 1, hSrcDC, xSrc + (ii / nXZoom), ySrc + (jj / nYZoom), dwRop
        Next ii
    Next jj

End Function

Public Function Rads(ByVal nDegrees As Double) As Double
Dim nRadians As Double
    nRadians = PI * nDegrees
    Rads = nRadians / 180
End Function

Private Function sckLabel(i As Integer) As String
    Select Case i
        Case 0:     sckLabel = "sckClosed"
        Case 1:     sckLabel = "sckOpen"
        Case 2:     sckLabel = "sckListening"
        Case 3:     sckLabel = "sckConnectionPending"
        Case 4:     sckLabel = "sckResolvingHost"
        Case 5:     sckLabel = "sckHostResolved"
        Case 6:     sckLabel = "sckConnecting"
        Case 7:     sckLabel = "sckConnected"
        Case 8:     sckLabel = "sckClosing"
        Case 9:     sckLabel = "sckError"
    End Select
End Function

